package com.muyu.Engineclient;

import com.muyu.domain.EngineVersion;
import com.muyu.remote.RemoteVersionService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @Author：qdm
 * @Package：com.muyu.Engineclient
 * @Project：cloud-etl-engine
 * @name：RuleEngineClientRunner
 * @Date：2024/8/29 11:05
 */
@Log4j2
@Component
public class RuleEngineClientRunner implements ApplicationRunner {
    @Autowired
    private RemoteVersionService remoteVersionService;

    @Override
    public void run(ApplicationArguments args) throws Exception {
        com.muyu.domain.constants.Result<List<EngineVersion>> listResult = remoteVersionService.selectVersionList();
        log.info(listResult);
        List<EngineVersion> engineVersionList = listResult.getData();
        RuleEngineInit.init(engineVersionList);
    }
}
