package com.muyu.Engineclient;

import com.muyu.domain.EngineVersion;
import com.muyu.domain.constants.RuleOperationConstants;
import com.muyu.dynamicLoad.DynamicLoader;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Component
public class RuleEngineInit {
    private static Map<Long, Map<String, byte[]>> engineMap = new HashMap();

    public static void init(List<EngineVersion> engineVersionList) {
        engineVersionList.stream().forEach(engineVersion -> {
            String content = engineVersion.getRuleContent().replaceAll("\r\n", "");
            Map<String, byte[]> bytecode = DynamicLoader.compile(engineVersion.getVersionClass() +
                    RuleOperationConstants.FILE_SUFFIX, content);
            engineMap.put(engineVersion.getId(), bytecode);
        });
    }

    public static Map<String, byte[]> getEngineMap(Long ruleId) {
        return engineMap.get(ruleId);
    }
}
