package com.muyu.context;

import com.muyu.model.process.DataSetProcessModel;
import lombok.Data;
import lombok.experimental.SuperBuilder;

/**
 * 数据集上下文
 *
 * @ClassName DataSetContextHolder
 * @Author qdm
 * @Version: 1.0
 */
@Data
@SuperBuilder
public class DataSetContextHolder {
    private static final ThreadLocal<DataSetProcessModel> THREAD_LOCAL = new ThreadLocal<>();

    private TaskContextHolder taskContextHolder;

    public static DataSetContextHolder build(TaskContextHolder taskContextHolder) {
        return DataSetContextHolder.builder()
                .taskContextHolder(taskContextHolder)
                .build();
    }

    public static DataSetProcessModel get() {
        return THREAD_LOCAL.get();
    }

    public static void set(DataSetProcessModel dataSetProcessModel) {
        THREAD_LOCAL.set(dataSetProcessModel);
    }

    public static void remove() {
        THREAD_LOCAL.remove();
    }
}
